﻿using UnityEngine;
using System.Collections;

public class AlchemyItem : InteractScript
{
	
	public float completionTime;
	public bool busy = false;
	public float currentTime;
	public bool completed = false;
	GUIManager manager;
	
	// Use this for initialization
	void Start()
	{
		manager = GameObject.FindGameObjectWithTag("GUIManager").GetComponent<GUIManager>();
		currentTime = 0;
		
	}
	
	// Update is called once per frame
	void Update()
	{
		
		if (busy)
			if (currentTime > 0f)
		{
			currentTime -= Time.deltaTime;
			completed = false;
		} else
		{
			completed = true;
			Complete();
		}
		
	}
	
	public void showMenu(){
		manager.openRecipes();
	}
	
	void Interact(){
		Debug.Log("I am being interacted with!");
	}
	
	public void startInteract()
	{
		
		if (!busy)
		{
			if (currentTime <= 0)
				currentTime = completionTime;
			busy = true;
			Debug.Log("Interaction Started");
		}
	}
	
	public void stopInteract()
	{
		
		busy = false;
		Debug.Log("Cancelled");
	}
	
	public void Complete(){
		
		Debug.Log("I am completed");
		currentTime = 0;
		busy = false;
	}
}
