﻿using UnityEngine;
using System.Collections;
using UnityEngine.UI;
using UnityEngine.EventSystems;

public class CraftSlot : MonoBehaviour, IPointerClickHandler {

	public bool active;
	Image itemImage;
	public int slotNumber;
	public int itemAmount = 1;
	RecipePanel recipePanel;
	Text itemAmountText;
	GUIManager manager;

	// Use this for initialization
	void Start () {

		itemImage = gameObject.transform.GetChild(0).GetComponent<Image>();
		itemAmountText = gameObject.transform.GetChild(1).GetComponent<Text>();
		recipePanel = GameObject.FindGameObjectWithTag("Recipes").GetComponent<RecipePanel>();
		manager = GameObject.FindGameObjectWithTag("GUIManager").GetComponent<GUIManager>();
	
	}
	
	// Update is called once per frame
	void Update () {

		if(slotNumber < recipePanel.showRecipes.Count)
			active = true;
		else
			active = false;
		
		if (active) {
			itemImage.enabled = true;
			itemImage.sprite = recipePanel.showRecipes[slotNumber].finalItem.itemIcon;
		} else{
			itemImage.enabled = false;
			itemAmountText.enabled = false;
		}
	
	}

	public void OnPointerClick(PointerEventData data)
	{
		if(active){
			manager.openAlchemy(recipePanel.showRecipes[slotNumber]);
		}
	}
	/*
	public void OnDrop(PointerEventData data){
		if(inventory.draggingItem){
			if(item == null){
				item = new Item(inventory.draggedItem);
				inventory.closeDraggedItem();
			}
			else{
				Item temp = item;
				item = inventory.draggedItem;
				inventory.showDraggedItem(temp, - 1);
			}
		}
	}*/

}
