﻿using UnityEngine;
using System.Collections;

public class GUIManager : MonoBehaviour {

	public GameObject alchemy;
	public GameObject recipes;
	public GameObject inventory;
	public bool inMenu = false;
	public int alchemySlot;

	// Use this for initialization
	void Start () {
		
		closeAll();
	
	}
	
	// Update is called once per frame
	void Update () {
	
	}

	public void closeAll(){
		alchemy.GetComponent<CanvasGroup>().alpha = 0;
		inventory.GetComponent<CanvasGroup>().alpha = 0;
		recipes.GetComponent<CanvasGroup>().alpha = 0;
		alchemy.SetActive(false);
		inventory.SetActive(false);
		recipes.SetActive(false);
		inMenu = false;
	}


	public void openAlchemy(Recipe recipe){

		closeAll();
		alchemy.SetActive(true);
		alchemy.GetComponent<AlchemyPanel>().recipe = recipe;
		alchemy.GetComponent<AlchemyPanel>().show();
		alchemy.GetComponent<CanvasGroup>().alpha = 1;
		inMenu = true;
	}

	public void openRecipes(){

		closeAll();
		recipes.SetActive(true);
		recipes.GetComponent<CanvasGroup>().alpha = 1;
		inMenu = true;
	}

	public void openInventory(int slot, int type){

		inventory.SetActive(true);
		alchemySlot = slot;
		inventory.GetComponent<InventoryScript>().startType = type;
		
		GameObject.FindGameObjectWithTag("Inventory").GetComponent<InventoryScript>().showItemsType(type);
		inventory.GetComponent<InventoryScript>().showItemsType(type);
		inventory.GetComponent<CanvasGroup>().alpha = 1;
		inMenu = true;
	}

	public void setAlchemySlot(Item item){
		alchemy.GetComponent<AlchemyPanel>().Slots[alchemySlot].GetComponent<AlchemySlot>().setItem(item);
	}
}
