﻿using UnityEngine;
using UnityEngine.UI;
using System;
using System.Collections;
using System.Collections.Generic;

public class InventoryScript : MonoBehaviour
{

	public GameObject slots;
	public List<GameObject> Slots = new List<GameObject>();
	public List<Item> Items = new List<Item>();
	public List<Item> showItems = new List<Item>();
	public bool showAll = true;
	public List<int> showIndexes = new List<int>();
	ItemDatabase database;
	public GameObject tooltip;
	public int startType;


	// Use this for initialization
	void Start()
	{
		tooltip.SetActive(false);
		int Slotamount = 0;
        
		database = GameObject.FindGameObjectWithTag("ItemDatabase").GetComponent<ItemDatabase>();
		/*
		for (int i = 0; i < 10; i++) {
			GameObject slot = (GameObject)Instantiate(slots);
			slot.GetComponent<SlotScript>().slotNumber = Slotamount;
			Slots.Add(slot);
			//Items.Add(new Item());
			slot.transform.SetParent(this.transform,false);
			slot.name = "Slot" + i;
			Slotamount ++;
		}*/
        

		showallItems();
			
	}

	void Update()
	{

	}
    
	public void showallItems()
	{
		showAll = true;
		showItems = new List<Item>();
		showIndexes.Clear();
		showItems = Items;
		for (int i = 0; i < Items.Count; i++)
			showIndexes.Add(i);

	}

	public void showItemsType(int itemtype)
	{
		showAll = false;
		showItems = new List<Item>();
		showIndexes.Clear();
		Item.ItemType type = (Item.ItemType)itemtype;
		for (int i = 0; i <Items.Count; i++) {
			Item item = Items [i];
			if (item.itemType == type) {
				showItems.Add(item);
				showIndexes.Add(i);
			}
		}

	}

	public void removeItem(int place)
	{
		Items.RemoveAt(place);
	}

	public void addItem(int id)
	{

		for (int i = 0; i < database.items.Count; i++) {
			if (database.items [i].itemId == id) {
				Item item = database.items [i];
				if (database.items [i].itemStackable) {
					checkIfItemExists(id, item);
					break;
				} else {
					addItemAtEmptySlot(item);
					break;
				}
			}
		}
        
        
	}

	public void checkIfItemExists(int itemID, Item item)
	{
		bool placed = false;
		for (int i = 0; i < Items.Count; i++) {
			if (Items [i].itemId == itemID) {
				if (Items [i].itemAmount == Items [i].itemMaxStack)
					continue;
				Items [i].itemAmount ++; 
				placed = true;
				break;

			} 
		} 
		if (!placed) {
			addItemAtEmptySlot(item);
		}
	}

	void addItemAtEmptySlot(Item item)
	{
		Items.Add(new Item(item));
	}
    
	public void showTooltip(Vector3 toolPosition, Item item)
	{
        
		float InventoryPanel = this.GetComponent<RectTransform>().localPosition.x;
		Vector3 toolPos = toolPosition;
		toolPos.x += InventoryPanel / (float)2;
		tooltip.SetActive(true);
		tooltip.GetComponent<RectTransform>().localPosition = toolPos;
        
		tooltip.transform.GetChild(0).GetComponent<Text>().text = item.itemName;
		tooltip.transform.GetChild(1).GetComponent<Text>().text = item.itemDesc;
	}

	public void closeTooltip()
	{
		tooltip.SetActive(false);
	}
}
