﻿using UnityEngine;
using System.Collections;

[System.Serializable]

public class Item {

	public string itemName;
	public int itemId;
	public Sprite itemIcon;
	public int itemAmount = 1;
	public int itemValue;
    public ItemType itemType;
    public string itemDesc;
	public bool itemStackable;
	public int itemMaxStack = 2;


	public enum ItemType{
		liquid = 0,
		plant = 1,
		potion = 2,
		bottle
	}

	public Item(string name, int id, int value, string desc, ItemType type, bool stackable){

		itemName = name;
		itemId = id;
        itemIcon = Resources.Load<Sprite>("Items/"+itemName);
		itemValue = value;
		itemType = type;
        itemDesc = desc;
		itemStackable = stackable;

	}

	public Item(Item item){
		
		itemName = item.itemName;
		itemId = item.itemId;
		itemIcon = Resources.Load<Sprite>("Items/"+itemName);
		itemValue = item.itemValue;
		itemType = item.itemType;
		itemDesc = item.itemDesc;
		itemStackable = item.itemStackable;
		itemMaxStack = item.itemMaxStack;
		
	}

	public Item(){
	}


}
