﻿using UnityEngine;
using System.Collections;
using UnityEngine.EventSystems;

public class InputScript : MonoBehaviour
{
	enum Action
	{
		move,
		changePlayer,
		interactItem,
		moveToItem,
		nothing
	}

	Action nextAction;
	public Vector2 worldPoint;
	private Transform clickedObject;
   // private CharacterScript chr;
    private CharacterControl chrAI;
	private PathfindingScript _PathFinder;
	//  private ItemScript item;
	QuestManager manager;

	// Use this for initialization
	void Start()
	{
        //chr = GameObject.FindGameObjectWithTag("Player").GetComponent<CharacterScript>();
        chrAI = GameObject.FindGameObjectWithTag("Player").GetComponent<CharacterControl>();
		_PathFinder = this.GetComponent<PathfindingScript>();
		manager = GameObject.FindGameObjectWithTag("QuestManager").GetComponent<QuestManager>();
	}

	// Update is called once per frame
	void Update()
	{
		int action;
		if (Input.GetMouseButtonDown(0) && !manager.inMenu) {
			if (checkTouch(Input.mousePosition))
				switch (nextAction) {
					case Action.changePlayer:
						//chr = clickedObject.GetComponent<CharacterScript>();
                        chrAI = clickedObject.GetComponent<CharacterControl>();
                        break;
				    case Action.interactItem:
						clickedObject.GetComponent<InteractScript>().showMenu();
                        break;

				//show up item menu if it has it
				}

		}
		if (Input.GetMouseButtonDown(1) && !manager.inMenu) {
			if (checkTouch(Input.mousePosition))
				switch (nextAction) {
					case Action.move:
						int goalIndex = _PathFinder.FindPath((Vector2)chrAI.transform.position, worldPoint);
						if (goalIndex >= 0)
							//chr.analysePath(_PathFinder.camefrom, goalIndex, worldPoint);
                            chrAI.analysePath(_PathFinder.camefrom, goalIndex, worldPoint);
						break;
                    case Action.interactItem:
                        goalIndex = _PathFinder.FindPath((Vector2)chrAI.transform.position, worldPoint);
                        if (goalIndex >= 0)
                            chrAI.analysePath(_PathFinder.camefrom, goalIndex, worldPoint);
                        chrAI.interactTarget = clickedObject;
                        break;
				//   case 3:
				//set interactible object item = clickedobject
				//chr.hasPurpose = true;
				}

		}

	}
	/// <summary>
	/// Checks if the Touch/Click is on acceptable bounds or if it hits a gameObject
	/// </summary>
	/// <param name="pos">Position.</param>
	private bool checkTouch(Vector3 pos)
	{
		bool onScreen = false;
		worldPoint = Camera.main.ScreenToWorldPoint(pos);
		RaycastHit2D[] hits = Physics2D.RaycastAll(worldPoint, Vector2.zero);
		if (hits != null) {
			foreach (RaycastHit2D hit in hits) {
				Transform obj = hit.collider.transform;
				if (obj.name == "MapCollider") {
					worldPoint = hit.point;
					nextAction = Action.move;
					onScreen = true;
				} else if (obj.CompareTag("Player")) {
					clickedObject = obj;
					nextAction = Action.changePlayer;
				} else if (obj.CompareTag("Item")) {
					clickedObject = obj;
					nextAction = Action.interactItem;
				}
			}
		}
		return onScreen;
	}
}
