﻿using UnityEngine;
using System.Collections;

public class InteractScript : MonoBehaviour
{

    public float completionTime;
    public bool busy = false;
    public float currentTime;
    public bool completed = false;
	QuestManager manager;
	public Quest currentQuest;
	QuestLog questLog;
	public int Id;
	public int questId;

    // Use this for initialization
    void Start()
    {
		manager = GameObject.FindGameObjectWithTag("QuestManager").GetComponent<QuestManager>();
		currentTime = 0;
		questLog = GameObject.FindGameObjectWithTag("QuestLog").GetComponent<QuestLog>();
		questId = -1;
		
	}
    
    // Update is called once per frame
    void Update()
    {

		if (busy && !manager.inMenu && questId >= 0)
	        if (currentTime > 0f)
	        {
	            currentTime -= Time.deltaTime;
	            completed = false;
	        } else
	        {
	            completed = true;
	            Complete();
	        }
    
    }

	public void showMenu(){
		manager.enableToggles(Id);
	}

	public void assignQuest(int id){

		currentQuest = questLog.quests[id];
		questId = id;
		completionTime = currentQuest.noOfItems * 1;

	}

    void Interact(){
        Debug.Log("I am being interacted with!");
    }

    public void startInteract()
    {

        if (!busy)
        {
            if (currentTime <= 0)
                currentTime = completionTime;
            busy = true;
            Debug.Log("Interaction Started");
        }
    }

    public void stopInteract()
    {

        busy = false;
        Debug.Log("Cancelled");
    }

    public void Complete(){

        Debug.Log("I am completed");
        currentTime = 0;
        busy = false;
		manager.completeQuest(questId);
		questId = -1;
		currentQuest = null;
    }
}
