﻿using UnityEngine;
using System.Collections;

public class InteractState : FSMState {

    CharacterControl character;
    InteractScript item;
    
    public InteractState(CharacterControl chara)
    {
        stateID = StateID.Interact;
        character = chara;
    }

    public override void DoBeforeEntering(){

        item = character.interactTarget.gameObject.GetComponent<InteractScript>();
        
        item.startInteract();
    }
    
    public override void Reason(){

        if(item.completed)
            character.SetTransition(Transition.TaskCompleted);
        
    }
    
    public override void Act(){

        
    }
    public override void DoBeforeLeaving(){

       item.stopInteract();
		character.interactTarget = null;
		item = null;

    }
}
