﻿using UnityEngine;
using UnityEngine.UI;
using System.Collections;
using System.Collections.Generic;

public class QuestLog : MonoBehaviour
{

	public GameObject textPrefab;
	public List<Quest> quests = new List<Quest>();
	List<GameObject> texts = new List<GameObject>();
	public int textCount;
	QuestManager manager;

	// Use this for initialization
	void Start()
	{
		
		manager = GameObject.FindGameObjectWithTag("QuestManager").GetComponent<QuestManager>();
		textCount = 1;
	}
	
	// Update is called once per frame
	void Update()
	{

		if (quests.Count > 10) {
			Debug.Log("Game Over");
		}
	
	}

	public void dayPassed()
	{
		for (int i = quests.Count - 1; i >= 0; i--) {
			Quest quest = quests[i];
			quest.deadline--;
			if (quest.deadline <= 0) {
				GameObject[] items = GameObject.FindGameObjectsWithTag("Item");
				foreach (GameObject item in items) {
					InteractScript itemScr = item.GetComponent<InteractScript>();
					if (itemScr.questId == i) {
						itemScr.questId = -1;
					}
				}
				manager.cancelQuest(i);
				quests.RemoveAt(i);
			}
		}

	}

	public void addQuest(Quest newquest)
	{

		quests.Add(newquest);
		
		GameObject text = (GameObject)Instantiate(textPrefab);
		text.transform.SetParent(transform, false);
		texts.Add(text);
		text.GetComponent<TextScript>().id = textCount++;

	}

	public void removeQuest(int place)
	{
		quests.RemoveAt(place);
	}

	public void enableToggles()
	{

		foreach (GameObject text in texts) {
			text.GetComponent<Toggle>().interactable = true;

		}
	}

	public void disableToggles()
	{

		foreach (GameObject text in texts) {
			text.GetComponent<Toggle>().interactable = false;
			
		}

	}
}
