﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class WalkState : FSMState
{
    public float speed = 3;
    bool renew = true;
    CharacterControl character;

    public WalkState(CharacterControl chara)
    {
        stateID = StateID.Walk;
        character = chara;
    }

    public override void DoBeforeEntering()
    {

        renew = true;
    }

    public override void Reason()
    {

        Vector2 moveDir = character.goalPos - (Vector2)character.transform.position;
        if (Mathf.Abs(moveDir.x) <= 0.1)
        {
            if (Mathf.Abs(moveDir.y) <= 1)
            {
                character.rigidbody2D.velocity = Vector2.zero;
                character.SetTransition(Transition.ReachedGoal);

            }
        }
    }
    
    public override void Act()
    {


        Vector2 vel = character.rigidbody2D.velocity;
        Vector2 moveDir = character.nextWaypoint - (Vector2)character.transform.position;
        if (Mathf.Abs(moveDir.x) <= 0.1)
        {
            if (Mathf.Abs(moveDir.y) <= 1)
            {
                if (character.path.Count != 0)
                {
                    character.nextWaypoint = character.path.Pop();
                }
                
            } else
                character.transform.position = character.nextWaypoint;
        }
        vel = moveDir.normalized * speed;
        vel.y = 0;
        character.rigidbody2D.velocity = vel;
    }

    public override void DoBeforeLeaving()
    {

     

    }
}
